// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marine_sensor_msgs:msg/RadarEcho.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marine_sensor_msgs/msg/radar_echo.hpp"


#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__marine_sensor_msgs__msg__RadarEcho __attribute__((deprecated))
#else
# define DEPRECATED__marine_sensor_msgs__msg__RadarEcho __declspec(deprecated)
#endif

namespace marine_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarEcho_
{
  using Type = RadarEcho_<ContainerAllocator>;

  explicit RadarEcho_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit RadarEcho_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _echoes_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _echoes_type echoes;

  // setters for named parameter idiom
  Type & set__echoes(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->echoes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> *;
  using ConstRawPtr =
    const marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marine_sensor_msgs__msg__RadarEcho
    std::shared_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marine_sensor_msgs__msg__RadarEcho
    std::shared_ptr<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarEcho_ & other) const
  {
    if (this->echoes != other.echoes) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarEcho_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarEcho_

// alias to use template instance with default allocator
using RadarEcho =
  marine_sensor_msgs::msg::RadarEcho_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marine_sensor_msgs

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_HPP_
