// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marine_sensor_msgs:msg/RadarEcho.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marine_sensor_msgs/msg/radar_echo.hpp"


#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__TRAITS_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marine_sensor_msgs/msg/detail/radar_echo__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace marine_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RadarEcho & msg,
  std::ostream & out)
{
  out << "{";
  // member: echoes
  {
    if (msg.echoes.size() == 0) {
      out << "echoes: []";
    } else {
      out << "echoes: [";
      size_t pending_items = msg.echoes.size();
      for (auto item : msg.echoes) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RadarEcho & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: echoes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.echoes.size() == 0) {
      out << "echoes: []\n";
    } else {
      out << "echoes:\n";
      for (auto item : msg.echoes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RadarEcho & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marine_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marine_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marine_sensor_msgs::msg::RadarEcho & msg,
  std::ostream & out, size_t indentation = 0)
{
  marine_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marine_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marine_sensor_msgs::msg::RadarEcho & msg)
{
  return marine_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marine_sensor_msgs::msg::RadarEcho>()
{
  return "marine_sensor_msgs::msg::RadarEcho";
}

template<>
inline const char * name<marine_sensor_msgs::msg::RadarEcho>()
{
  return "marine_sensor_msgs/msg/RadarEcho";
}

template<>
struct has_fixed_size<marine_sensor_msgs::msg::RadarEcho>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marine_sensor_msgs::msg::RadarEcho>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marine_sensor_msgs::msg::RadarEcho>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__TRAITS_HPP_
